"{ Package: 'stx:goodies/monticello' }"

LibraryDefinition subclass:#stx_goodies_monticello
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!stx_goodies_monticello class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:libbasic'    "Object - superclass of MCAncestry "
        #'stx:libbasic2'    "UUID - referenced by MCMockDependency>>uuidForName: "
        #'stx:libcomp'    "Scanner - referenced by MCStReader>>categoryFromDoIt: "
        #'stx:libcompat'    "PackageInfo - referenced by MCPackage>>packageInfo "
        #'stx:libwidg'    "PopUpMenu - referenced by MCDictionaryRepository>>morphicOpen: "
    )
! !

!stx_goodies_monticello class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        MCAncestry
        (MCChangeSelectionRequest autoload)
        (MCChangeSelector autoload)
        (MCCodeTool autoload)
        MCConflict
        MCDefinition
        MCDefinitionIndex
        MCDependencySorter
        (MCDependentsWrapper autoload)
        (MCDiffyVersion autoload)
        (MCDirtyPackageInfo autoload)
        (MCDoItParser autoload)
        (MCEmptyPackageInfo autoload)
        (MCFileRepositoryInspector autoload)
        (MCFrontier autoload)
        (MCFtpRepository autoload)
        (MCGOODSRepository autoload)
        (MCHttpRepository autoload)
        (MCMcdReader autoload)
        (MCMcdWriter autoload)
        (MCMczReader autoload)
        (MCMczWriter autoload)
        (MCMergeBrowser autoload)
        (MCMergeRecord autoload)
        (MCMergeResolutionRequest autoload)
        MCMerger
        MCMock
        (MCMockAPoolDictionary autoload)
        (MCMockASubclass autoload)
        (MCMockClassB autoload)
        (MCMockClassD autoload)
        (MCMockClassE autoload)
        (MCMockClassF autoload)
        (MCMockClassG autoload)
        (MCMockClassH autoload)
        (MCMockClassI autoload)
        MCMockDependency
        MCMockPackageInfo
        (MCNoChangesException autoload)
        MCPackage
        (MCPackageCache autoload)
        (MCPackageLoader autoload)
        MCPackageManager
        MCPatch
        (MCPatchBrowser autoload)
        MCPatchOperation
        MCPatcher
        (MCPostscriptDefinition autoload)
        (MCPreambleDefinition autoload)
        MCReader
        (MCRemovalPostscriptDefinition autoload)
        (MCRemovalPreambleDefinition autoload)
        MCRepository
        (MCRepositoryGroup autoload)
        (MCRepositoryInspector autoload)
        (MCSMCacheRepository autoload)
        (MCSMReleaseRepository autoload)
        (MCSaveVersionDialog autoload)
        (MCScanner autoload)
        (MCScriptDefinition autoload)
        (MCSmtpRepository autoload)
        MCSnapshot
        (MCSnapshotBrowser autoload)
        (MCStWriter autoload)
        (MCSubDirectoryRepository autoload)
        (MCSystemCategoryParser autoload)
        (MCTool autoload)
        (MCToolWindowBuilder autoload)
        MCVariableDefinition
        MCVersion
        (MCVersionDependency autoload)
        (MCVersionHistoryBrowser autoload)
        (MCVersionInfoWriter autoload)
        (MCVersionInspector autoload)
        (MCVersionLoader autoload)
        (MCVersionMerger autoload)
        (MCVersionNameAndMessageRequest autoload)
        (MCVersionNotification autoload)
        (MCVersionReader autoload)
        MCVersionSorter
        (MCWorkingCopyBrowser autoload)
        (MCWorkingHistoryBrowser autoload)
        (MCWriteOnlyRepository autoload)
        (MCWriter autoload)
        #'stx_goodies_monticello'
        MCAddition
        MCClassDefinition
        MCClassInstanceVariableDefinition
        MCClassVariableDefinition
        MCDictionaryRepository
        MCFileBasedRepository
        MCFilteredVersionSorter
        MCInstanceVariableDefinition
        MCMethodDefinition
        MCMockClassA
        MCMockDefinition
        MCMockDependentItem
        MCModification
        MCOrganizationDefinition
        MCPoolImportDefinition
        MCRemoval
        MCSnapshotReader
        MCThreeWayMerger
        MCVersionInfo
        MCWorkingAncestry
        MCWorkingCopy
        MCDirectoryRepository
        MCStReader
        MCCacheRepository
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Behavior typeOfClass
        Class asClassDefinition
        Class classDefinitions
        Class poolDictionaryNames
        ClassBuilder name:inEnvironment:subclassOf:type:instanceVariableNames:classVariableNames:poolDictionaries:category:
        Object isConflict
        Stream isMessageStream
        String extractNumber
        UndefinedObject typeOfClass
    )
! !

!stx_goodies_monticello class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2010\nCopyright eXept Software AG 1998-2010'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_goodies_monticello class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/stx_goodies_monticello.st,v 1.1 2010-10-30 12:39:56 cg Exp $'
! !
